Adresse[] adressen;
int vergleiche = 0;
 
void setup() {  
  Table table = loadTable("l2-adressdaten_sortiert.csv", "csv");
 
  int anzahl = table.getRowCount();
  adressen = new Adresse[anzahl];
 
  int i = 0;
 
  for (TableRow row : table.rows()) {  
    String nachname = row.getString(0);
    String vorname = row.getString(1);
    String adresse = row.getString(2);
    String plz = row.getString(3);
    String ort = row.getString(4);
 
    adressen[i++] = new Adresse(nachname, vorname, adresse, plz, ort);
  }
 
  String vorname = "Nadine";
  String nachname = "Muench";
  Adresse adresse = suche(nachname, vorname);
 
  println("Die Suche benötigte " + vergleiche + " Vergleiche!");
 
  if (adresse != null) {
    println(vorname + " " + nachname + " wohnt in " + adresse.getAdresse()  + ", " + adresse.getPlz() + " " + adresse.getOrt());
  } else {
    println("Keine Adresse von " + vorname + " " + nachname + " gefunden!");
  }
}
 
Adresse suche(String nachname, String vorname) {
  int links = 0;
  int rechts = adressen.length - 1;
 
  while (links <= rechts) {
    int mitte = links + (rechts - links) / 2;
    Adresse a = adressen[mitte];
 
    if (a.getNachname().equals(nachname) && a.getVorname().equals(vorname)) {
      return adressen[mitte];
    }
 
    if (a.getNachname().compareTo(nachname) > 0) {
      rechts = mitte - 1;
    } else if (a.getNachname().compareTo(nachname) < 0) {
      links = mitte + 1;
    } else if (a.getVorname().compareTo(vorname) > 0) {
      rechts = mitte - 1;
    } else if (a.getVorname().compareTo(vorname) < 0) {
      links = mitte + 1;
    } 
 
    vergleiche++;
  }
 
  return null;
}
